//API Interface for Application and Device Driver
//Author:  Kevin Guo


#ifndef _XRAPI_H_
#define _XRAPI_H_



#define EXAR_XONXOFF	0xF0
#define EXAR_RTSCTS		0xF1
#define EXAR_DTRDSR		0xF2
#define EXAR_NOHANDSHAKE	0xF3

typedef struct _COM_PORT_CONFIG {
	unsigned char	Port;
	unsigned char	Dlm;
	unsigned char	Dll;
	unsigned char	WordLen;
	unsigned char	StopBits;
	unsigned char	Parity;
	unsigned char	FlowControl;
	BOOLEAN			FifoEnabled;
} COM_PORT_CONFIG,*PCOM_PORT_CONFIG;

typedef struct _COM_PORT_ENHANCED {
	unsigned char	FlowControl;
	unsigned char	TxFifoTriggerLevel;
	unsigned char	RxFifoTriggerLevel;
	unsigned char	Hysteresis;
	unsigned char	LoopBack;
	unsigned char	RS485;
	unsigned char   IR;
} COM_PORT_ENHANCED,*PCOM_PORT_ENHANCED;

typedef struct _COM_PORT_RW {
	unsigned char	RegAddr;
	unsigned char	OrVal;
	unsigned char	AndVal;
	unsigned char	ReadVal;
	unsigned char	rw;
} COM_PORT_RW,*PCOM_PORT_RW;
//
// Define the various device type values.  Note that values used by Microsoft
// Corporation are in the range 0-32767, and 32768-65535 are reserved for use
// by customers.
//

#define FILE_DEVICE_XRPORT  0x00008005

//
// Macro definition for defining IOCTL and FSCTL function control codes.  Note
// that function codes 0-2047 are reserved for Microsoft Corporation, and
// 2048-4095 are reserved for customers.
//

#define XRPORT_IOCTL_INDEX  0x805


#define IOCTL_XRPORT_SET_CONFIG   CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)

#define IOCTL_XRPORT_GET_CONFIG   CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX + 1,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)

#define IOCTL_XRPORT_SET_ENHANCED   CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX + 2,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)

#define IOCTL_XRPORT_RW				CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX + 3,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)

#define IOCTL_XRPORT_SET_LOOP      CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX + 4,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)

#define IOCTL_XRPORT_SET_RS485      CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX + 5,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)


#define REG_KEY_XRPORT1_SETTINGS			TEXT("Software\\Exar\\Xr158\\Settings\\Port1")
#define REG_KEY_XRPORT2_SETTINGS			TEXT("Software\\Exar\\Xr158\\Settings\\Port2")
#define REG_KEY_XRPORT3_SETTINGS			TEXT("Software\\Exar\\Xr158\\Settings\\Port3")
#define REG_KEY_XRPORT4_SETTINGS			TEXT("Software\\Exar\\Xr158\\Settings\\Port4")
#define REG_KEY_XRPORT5_SETTINGS			TEXT("Software\\Exar\\Xr158\\Settings\\Port5")
#define REG_KEY_XRPORT6_SETTINGS			TEXT("Software\\Exar\\Xr158\\Settings\\Port6")
#define REG_KEY_XRPORT7_SETTINGS			TEXT("Software\\Exar\\Xr158\\Settings\\Port7")
#define REG_KEY_XRPORT8_SETTINGS			TEXT("Software\\Exar\\Xr158\\Settings\\Port8")

#define THIRTYTWO_TX

#endif  //_XRAPI_H_