////////////////////////////////////////
//(c) 1999, 2000 EXAR Corporation 
//All Rights Reserved.
//
//Exar Corporation ("Exar") hereby grants the User of this Exar 
//product-specific XR17C158 Windows NT Device Driver (hereinafter 
//referred to as "Driver") a non-exclusive, nontransferable license 
//to use the Driver in accordance with the term set forth below.  
//Before using the Driver, the User should read the following use 
//restrictions.  If the User does not accept these terms, the Driver 
//should not be used or downloaded.
//The User is granted this limited license to use this Driver for 
//User's end product that includes the Exar XR17C158 Octal UART device, 
//and is not granted rights to sell, loan, rent, lease or license the 
//Driver, in whole or in part, or in modified form to anyone other 
//than User.  User may modify the Driver to suit its specific 
//applications but rights to derivative works and such modifications 
//shall belong to Exar.
//
//The Driver is provided on an "AS IS" basis and Exar makes absolutely 
//no warranty with respect to performance or the information contained 
//therein.  EXAR DISCLAIMS AND USER WAIVES ALL WARRANTIES, EXPRESS OR 
//IMPLIED, INCLUDING WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A 
//PARTICULAR PURPOSE.  The entire risk as to Driver quality and 
//performance is with the User.  ACCORDINGLY, IN NO EVENT SHALL EXAR 
//BE LIABLE FOR ANY DAMAGES, WHETHER IN CONTRACT OR TORT, INCLUDING 
//ANY LOST PROFITS OR OTHER INCIDENTAL, CONSEQUENTIAL, EXEMPLARY, OR 
//PUNITIVE DAMAGES ARISING OUT OF THE USE OR APPLICATION OF THE DRIVER.  
//Further, Exar reserves the right to make changes tot eh Driver without 
//notice to improve reliability, function or design.  Exar does not 
//convey any license under patent rights or any other intellectual 
//property rights, including those of third parties.
//
//Exar is not obligated to provide maintenance or support for the Driver. 
//
//Author:	Kevin Guo
//
////////////////////////////////////////////

#include "stdafx.h"

#include <windows.h>
#include <winioctl.h>
#include <stdio.h>
#include <conio.h>
#include "pciconfig.h"
#include "ioaccess.h"

// A couple of typedefs mapmem.h depends on from  MINIPORT.H & NTDDK.H.
//

typedef enum _INTERFACE_TYPE
{
    Internal,
    Isa,
    Eisa,
    MicroChannel,
    TurboChannel,
    MaximumInterfaceType
} INTERFACE_TYPE, *PINTERFACE_TYPE;

typedef LARGE_INTEGER PHYSICAL_ADDRESS;

#include "mapmem.h"

// constructor that goes out and gets the configuration base addresses (either
// from the simulator OR from the PCI configuration.
CPciConfig::CPciConfig() 
{
#define WIN2K
#ifdef WIN2K
			
	if ((hDriver = CreateFile("\\\\.\\COM5",
				      GENERIC_READ | GENERIC_WRITE,
				      FILE_SHARE_WRITE,
				      NULL,
				      OPEN_EXISTING,
				      FILE_ATTRIBUTE_NORMAL,
				      NULL
				      )) != ((HANDLE)-1))
	{
		m_dwPCIMemBase = 0xFFFF;
	}
	else
	{
		MessageBox(NULL, "Error in opening the port COM5, Application will exit!", "Error", MB_OK);
		//exit(1);
		ExitProcess(1);
	}
	return;
	
#endif
	if ( 1 )
	{
	    char *devname = "\\\\.\\MAPMEM";
	    HANDLE hDriver;
	    DWORD  cbReturned;
	    PHYSICAL_MEMORY_INFO pmi;

		if ((hDriver = CreateFile(devname,
				      GENERIC_READ | GENERIC_WRITE,
				      FILE_SHARE_WRITE,
				      NULL,
				      OPEN_EXISTING,
				      FILE_ATTRIBUTE_NORMAL,
				      NULL
				      )) != ((HANDLE)-1))
		printf ("\nRetrieved valid handle for MAPMEM driver\n");
	    else
		printf("Cannot find %s\n",devname);


	    //
	    // Try to map the memory
	    //

	    if (!DeviceIoControl(hDriver,
				 (DWORD) IOCTL_MAPMEM_MAP_USER_PHYSICAL_MEMORY,
				 &pmi,
				 sizeof(PHYSICAL_MEMORY_INFO),
				 &m_dwBaseAddr0,
				 sizeof(PVOID),
				 &cbReturned,
				 0
				 ))
			printf("Unable to map physical memory\n");
	    else
			printf("Vortex physical address space mapped to 0x%x\n",
				m_dwBaseAddr0);
	}
	m_dwPCIMemBase = m_dwBaseAddr0;
}


/*
 * The destructor uses the address translator VxD to unlock and release 
 * all virtual addresses previously translated and locked by the application.
 */
CPciConfig::~CPciConfig() 
{

}

/*
 * GetMemBase will use PCI mechanism #1 to read the physical memory base address for 
 * Aspen.  It will also utilize the address translator VxD to convert the address to 
 * a virtual memory address.
 */


DWORD CPciConfig::GetBaseAddr0() {
	return m_dwBaseAddr0;
}

// Memory test: 
// CAUTION: when read, the ISR does NOT return the same data as written!

void CPciConfig::Dump(DWORD dwAddress, DWORD dwOffset, DWORD dwData, const char* lpszText) 
{
	char lpszTemp[82];
	strcpy(lpszTemp, "%#10x %#10x %#10x");
	strcat(lpszTemp, "       ");
	strcat(lpszTemp, lpszText);
	strcat(lpszTemp, "\n");
	printf(lpszTemp, dwAddress, dwOffset, dwData);
}



